#include <stdio.h>
#include <time.h>

extern int lu_decomposition (double *mat, int m, int n);

#define EPS .01

#ifdef LIBMAIN
int main(int argc, char** argv)
{
	int lc;
	int m=4, n=4;
	int result = 0;
	double mat[16] = { 1,  1,  0,  3,
				        2,  1, -1,  1,
				        3, -1, -1,  2,
				        -1, 2,  3, -1,};	

	double mat2[16] = { 1,  1,  0,  3,
				        2,  1, -1,  1,
				        3, -1, -1,  2,
				        -1, 2,  3, -1,};	
	
	
	//lu_decomposition(mat, m, n);
	lu_decomposition(mat2, m, n);



	
	result = validate_matrix(mat, mat2, mat2, m, n);
	
	printf("%d\n", result);
}
#endif

int
validate_matrix(double *qmat, double *umat, double *lmat, int m, int n)
{
	int lc, lc2;
	double *compmat;
	
	printf("Finish LU decomp / Time=%ld.\n", time(NULL));
	
	printf("START SERIAL LU decomp / Time=%ld.\n", time(NULL));
	lu_decomposition(qmat, m, n);
	printf("Finish SERIAL LU decomp / Time=%ld.\n", time(NULL));
	
	for(lc = 0; lc < n; lc++){
		for(lc2 = 0; lc2 < m; lc2++){
			if(n > m){
				compmat = lmat;
			}else{
				compmat = umat;
			}
			
			if(!( 
			       ((qmat[lc*m+lc2] - EPS) < compmat[lc*m+lc2]) 
				&& ((qmat[lc*m+lc2] + EPS) > compmat[lc*m+lc2])
				)){
					return 0;
				}
		}
	}
	return 1;
}